]> git.notmuchmail.org Git - notmuch/blob - test/test-lib.sh
test: trivial style cleanups
[notmuch] / test / test-lib.sh
1 #
2 # Copyright (c) 2005 Junio C Hamano
3 # Copyright (c) 2010 Notmuch Developers
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see https://www.gnu.org/licenses/ .
17
18 if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
19     echo "Error: The notmuch test suite requires a bash version >= 4.0"
20     echo "due to use of associative arrays within the test suite."
21     echo "Please try again with a newer bash (or help us fix the"
22     echo "test suite to be more portable). Thanks."
23     exit 1
24 fi
25
26 # Make sure echo builtin does not expand backslash-escape sequences by default.
27 shopt -u xpg_echo
28
29 # Ensure NOTMUCH_SRCDIR and NOTMUCH_BUILDDIR are set.
30 . $(dirname "$0")/export-dirs.sh || exit 1
31
32 # It appears that people try to run tests without building...
33 if [[ ! -x "$NOTMUCH_BUILDDIR/notmuch" ]]; then
34         echo >&2 'You do not seem to have built notmuch yet.'
35         exit 1
36 fi
37
38 this_test=${0##*/}
39 this_test=${this_test%.sh}
40 this_test_bare=${this_test#T[0-9][0-9][0-9]-}
41
42 # if --tee was passed, write the output not only to the terminal, but
43 # additionally to the file test-results/$BASENAME.out, too.
44 case "$GIT_TEST_TEE_STARTED, $* " in
45 done,*)
46         # do not redirect again
47         ;;
48 *' --tee '*|*' --va'*)
49         mkdir -p test-results
50         BASE=test-results/$this_test
51         (GIT_TEST_TEE_STARTED=done "$BASH" "$0" "$@" 2>&1;
52          echo $? > $BASE.exit) | tee $BASE.out
53         test "$(cat $BASE.exit)" = 0
54         exit
55         ;;
56 esac
57
58 # STDIN from /dev/null. EOF for readers (and ENOTTY for tty related ioctls).
59 exec </dev/null
60
61 # Save STDOUT to fd 6 and STDERR to fd 7.
62 exec 6>&1 7>&2
63 # Make xtrace debugging (when used) use redirected STDERR, with verbose lead:
64 BASH_XTRACEFD=7
65 export PS4='+(${BASH_SOURCE}:${LINENO}): ${FUNCNAME[0]:+${FUNCNAME[0]}(): }'
66
67 # Keep the original TERM for say_color and test_emacs
68 ORIGINAL_TERM=$TERM
69
70 # Set SMART_TERM to vt100 for known dumb/unknown terminal.
71 # Otherwise use whatever TERM is currently used so that
72 # users' actual TERM environments are being used in tests.
73 case ${TERM-} in
74         '' | dumb | unknown )
75                 SMART_TERM=vt100 ;;
76         *)
77                 SMART_TERM=$TERM ;;
78 esac
79
80 # For repeatability, reset the environment to known value.
81 LANG=C
82 LC_ALL=C
83 PAGER=cat
84 TZ=UTC
85 TERM=dumb
86 export LANG LC_ALL PAGER TERM TZ
87 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
88 if [[ ( -n "$TEST_EMACS" && -z "$TEST_EMACSCLIENT" ) || \
89       ( -z "$TEST_EMACS" && -n "$TEST_EMACSCLIENT" ) ]]; then
90     echo "error: must specify both or neither of TEST_EMACS and TEST_EMACSCLIENT" >&2
91     exit 1
92 fi
93 TEST_EMACS=${TEST_EMACS:-${EMACS:-emacs}}
94 TEST_EMACSCLIENT=${TEST_EMACSCLIENT:-emacsclient}
95 TEST_GDB=${TEST_GDB:-gdb}
96 TEST_CC=${TEST_CC:-cc}
97 TEST_CFLAGS=${TEST_CFLAGS:-"-g -O0"}
98 TEST_SHIM_CFLAGS=${TEST_SHIM_CFLAGS:-"-fpic -shared"}
99 TEST_SHIM_LDFLAGS=${TEST_SHIM_LDFLAGS:-"-ldl"}
100
101 # Protect ourselves from common misconfiguration to export
102 # CDPATH into the environment
103 unset CDPATH
104
105 unset GREP_OPTIONS
106
107 # For lib/open.cc:_load_key_file
108 unset XDG_CONFIG_HOME
109
110 # For emacsclient
111 unset ALTERNATE_EDITOR
112
113 # for reproducibility
114 unset EMAIL
115 unset NAME
116
117 test_require_emacs () {
118     test_require_external_prereq emacs
119     test_require_external_prereq ${TEST_EMACSCLIENT}
120     test_require_external_prereq dtach
121 }
122
123 add_gnupg_home ()
124 {
125     [ -e "${GNUPGHOME}/gpg.conf" ] && return
126     _gnupg_exit () { gpgconf --kill all 2>/dev/null || true; }
127     at_exit_function _gnupg_exit
128     mkdir -p -m 0700 "$GNUPGHOME"
129     gpg --no-tty --import <$NOTMUCH_SRCDIR/test/gnupg-secret-key.asc >"$GNUPGHOME"/import.log 2>&1
130     test_debug "cat $GNUPGHOME/import.log"
131     if (gpg --quick-random --version >/dev/null 2>&1) ; then
132         echo quick-random >> "$GNUPGHOME"/gpg.conf
133     elif (gpg --debug-quick-random --version >/dev/null 2>&1) ; then
134         echo debug-quick-random >> "$GNUPGHOME"/gpg.conf
135     fi
136     echo no-emit-version >> "$GNUPGHOME"/gpg.conf
137
138     # Change this if we ship a new test key
139     FINGERPRINT="5AEAB11F5E33DCE875DDB75B6D92612D94E46381"
140     SELF_USERID="Notmuch Test Suite <test_suite@notmuchmail.org> (INSECURE!)"
141     printf '%s:6:\n' "$FINGERPRINT" | gpg --quiet --batch --no-tty --import-ownertrust
142 }
143
144 add_gpgsm_home ()
145 {
146     local fpr
147     [ -e "$GNUPGHOME/gpgsm.conf" ] && return
148     _gnupg_exit () { gpgconf --kill all 2>/dev/null || true; }
149     at_exit_function _gnupg_exit
150     mkdir -p -m 0700 "$GNUPGHOME"
151     openssl pkcs12 -export -passout pass: -inkey "$NOTMUCH_SRCDIR/test/smime/key+cert.pem" \
152         < "$NOTMUCH_SRCDIR/test/smime/test.crt" | \
153         gpgsm --batch --no-tty --no-common-certs-import --pinentry-mode=loopback --passphrase-fd 3 \
154               --disable-dirmngr --import  >"$GNUPGHOME"/import.log 2>&1 3<<<''
155     fpr=$(gpgsm --batch --list-key test_suite@notmuchmail.org | sed -n 's/.*fingerprint: //p')
156     echo "$fpr S relax" >> "$GNUPGHOME/trustlist.txt"
157     gpgsm --quiet --batch --no-tty --no-common-certs-import --disable-dirmngr --import < $NOTMUCH_SRCDIR/test/smime/ca.crt
158     echo "4D:E0:FF:63:C0:E9:EC:01:29:11:C8:7A:EE:DA:3A:9A:7F:6E:C1:0D S" >> "$GNUPGHOME/trustlist.txt"
159     printf '%s::1\n' include-certs disable-crl-checks | gpgconf --output /dev/null --change-options gpgsm
160     gpgsm --batch --no-tty --no-common-certs-import --pinentry-mode=loopback --passphrase-fd 3 \
161               --disable-dirmngr --import "$NOTMUCH_SRCDIR/test/smime/bob.p12" >>"$GNUPGHOME"/import.log 2>&1 3<<<''
162     test_debug "cat $GNUPGHOME/import.log"
163 }
164
165 # Each test should start with something like this, after copyright notices:
166 #
167 # test_description='Description of this test...
168 # This test checks if command xyzzy does the right thing...
169 # '
170 # . ./test-lib.sh || exit 1
171
172 color=maybe
173
174 while test "$#" -ne 0
175 do
176         case "$1" in
177         -d|--debug)
178                 debug=t; shift ;;
179         -i|--immediate)
180                 immediate=t; shift ;;
181         -h|--help)
182                 help=t; shift ;;
183         -v|--verbose)
184                 verbose=t; shift ;;
185         -q|--quiet)
186                 quiet=t; shift ;;
187         --with-dashes)
188                 with_dashes=t; shift ;;
189         --no-color)
190                 color=; shift ;;
191         --no-python)
192                 # noop now...
193                 shift ;;
194         --valgrind)
195                 valgrind=t; verbose=t; shift ;;
196         --tee)
197                 shift ;; # was handled already
198         *)
199                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
200         esac
201 done
202
203 if test -n "$debug"; then
204     print_subtest () {
205         printf " %-4s" "[$((test_count - 1))]"
206     }
207 else
208     print_subtest () {
209         true
210     }
211 fi
212
213 test -n "$COLORS_WITHOUT_TTY" || [ -t 1 ] || color=
214
215 if [ -n "$color" ] && [ "$ORIGINAL_TERM" != 'dumb' ] && (
216                 TERM=$ORIGINAL_TERM &&
217                 export TERM &&
218                 tput bold
219                 tput setaf
220                 tput sgr0
221         ) >/dev/null 2>&1
222 then
223         color=t
224 else
225         color=
226 fi
227
228 if test -n "$color"; then
229         say_color () {
230                 (
231                 TERM=$ORIGINAL_TERM
232                 export TERM
233                 case "$1" in
234                         error) tput bold; tput setaf 1;; # bold red
235                         skip)  tput bold; tput setaf 2;; # bold green
236                         pass)  tput setaf 2;;            # green
237                         info)  tput setaf 3;;            # brown
238                         *) test -n "$quiet" && return;;
239                 esac
240                 shift
241                 printf " "
242                 printf "$@"
243                 tput sgr0
244                 print_subtest
245                 )
246         }
247 else
248         say_color() {
249                 test -z "$1" && test -n "$quiet" && return
250                 shift
251                 printf " "
252                 printf "$@"
253                 print_subtest
254         }
255 fi
256
257 error () {
258         say_color error "error: $*\n"
259         GIT_EXIT_OK=t
260         exit 1
261 }
262
263 say () {
264         say_color info "$*"
265 }
266
267 test "${test_description}" != "" ||
268 error "Test script did not set test_description."
269
270 if test "$help" = "t"
271 then
272         echo "Tests ${test_description}"
273         exit 0
274 fi
275
276 test_description_printed=
277 print_test_description ()
278 {
279         test -z "$test_description_printed" || return 0
280         echo
281         echo $this_test: "Testing ${test_description}"
282         test_description_printed=1
283 }
284 if [ -z "$NOTMUCH_TEST_QUIET" ]
285 then
286         print_test_description
287 fi
288
289 test_failure=0
290 test_count=0
291 test_fixed=0
292 test_broken=0
293 test_success=0
294
295 declare -a _exit_functions=()
296
297 at_exit_function () {
298         _exit_functions=($1 ${_exit_functions[@]/$1})
299 }
300
301 rm_exit_function () {
302         _exit_functions=(${_exit_functions[@]/$1})
303 }
304
305 _exit_common () {
306         code=$?
307         trap - EXIT
308         set +ex
309         for _fn in ${_exit_functions[@]}; do $_fn; done
310         rm -rf "$TEST_TMPDIR"
311 }
312
313 trap_exit () {
314         _exit_common
315         if test -n "$GIT_EXIT_OK"
316         then
317                 exit $code
318         else
319                 exec >&6
320                 say_color error '%-6s' FATAL
321                 echo " $test_subtest_name"
322                 echo
323                 echo "Unexpected exit while executing $0. Exit code $code."
324                 exit 1
325         fi
326 }
327
328 trap_signal () {
329         _exit_common
330         echo >&6 "FATAL: $0: interrupted by signal" $((code - 128))
331         exit $code
332 }
333
334 die () {
335         _exit_common
336         exec >&6
337         say_color error '%-6s' FATAL
338         echo " $*"
339         echo
340         echo "Unexpected exit while executing $0."
341         exit 1
342 }
343
344 GIT_EXIT_OK=
345 # Note: TEST_TMPDIR *NOT* exported!
346 TEST_TMPDIR=$(mktemp -d "${TMPDIR:-/tmp}/notmuch-test-$$.XXXXXX")
347 # Put GNUPGHOME in TMPDIR to avoid problems with long paths.
348 export GNUPGHOME="${TEST_TMPDIR}/gnupg"
349 trap 'trap_exit' EXIT
350 trap 'trap_signal' HUP INT TERM
351
352 # Deliver a message with emacs and add it to the database
353 #
354 # Uses emacs to generate and deliver a message to the mail store.
355 # Accepts arbitrary extra emacs/elisp functions to modify the message
356 # before sending, which is useful to doing things like attaching files
357 # to the message and encrypting/signing.
358 emacs_deliver_message ()
359 {
360     local subject body smtp_dummy_pid smtp_dummy_port
361     subject="$1"
362     body="$2"
363     shift 2
364     # before we can send a message, we have to prepare the FCC maildir
365     mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
366     # eval'ing smtp-dummy --background will set smtp_dummy_pid and -_port
367     smtp_dummy_pid= smtp_dummy_port=
368     eval `$TEST_DIRECTORY/smtp-dummy --background sent_message`
369     test -n "$smtp_dummy_pid" || return 1
370     test -n "$smtp_dummy_port" || return 1
371
372     test_emacs \
373         "(let ((message-send-mail-function 'message-smtpmail-send-it)
374                (mail-host-address \"example.com\")
375                (smtpmail-smtp-server \"localhost\")
376                (smtpmail-smtp-service \"${smtp_dummy_port}\"))
377            (notmuch-mua-mail)
378            (message-goto-to)
379            (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
380            (message-goto-subject)
381            (insert \"${subject}\")
382            (message-goto-body)
383            (insert \"${body}\")
384            $*
385            (notmuch-mua-send-and-exit))"
386
387     # In case message was sent properly, client waits for confirmation
388     # before exiting and resuming control here; therefore making sure
389     # that server exits by sending (KILL) signal to it is safe.
390     kill -9 $smtp_dummy_pid
391     notmuch new >/dev/null
392 }
393
394 # Pretend to deliver a message with emacs. Really save it to a file
395 # and add it to the database
396 #
397 # Uses emacs to generate and deliver a message to the mail store.
398 # Accepts arbitrary extra emacs/elisp functions to modify the message
399 # before sending, which is useful to doing things like attaching files
400 # to the message and encrypting/signing.
401 #
402 # If any GNU-style long-arguments (like --quiet or --decrypt=true) are
403 # at the head of the argument list, they are sent directly to "notmuch
404 # new" after message delivery
405 emacs_fcc_message ()
406 {
407     local nmn_args subject body
408     nmn_args=''
409     while [[ "$1" =~ ^-- ]]; do
410         nmn_args="$nmn_args $1"
411         shift
412     done
413     subject="$1"
414     body="$2"
415     shift 2
416     # before we can send a message, we have to prepare the FCC maildir
417     mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
418
419     test_emacs \
420         "(let ((message-send-mail-function (lambda () t))
421                (mail-host-address \"example.com\"))
422            (notmuch-mua-mail)
423            (message-goto-to)
424            (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
425            (message-goto-subject)
426            (insert \"${subject}\")
427            (message-goto-body)
428            (insert \"${body}\")
429            $*
430            (let ((mml-secure-smime-sign-with-sender t)
431                  (mml-secure-openpgp-sign-with-sender t))
432              (notmuch-mua-send-and-exit)))" || return 1
433     notmuch new $nmn_args >/dev/null
434 }
435
436 # Add an existing, fixed corpus of email to the database.
437 #
438 # $1 is the corpus dir under corpora to add, using "default" if unset.
439 #
440 # The default corpus is based on about 50 messages from early in the
441 # history of the notmuch mailing list, which allows for reliably
442 # testing commands that need to operate on a not-totally-trivial
443 # number of messages.
444 add_email_corpus ()
445 {
446     local corpus
447     corpus=${1:-default}
448
449     rm -rf ${MAIL_DIR}
450     cp -a $NOTMUCH_SRCDIR/test/corpora/$corpus ${MAIL_DIR}
451     notmuch new >/dev/null || die "'notmuch new' failed while adding email corpus"
452 }
453
454 test_begin_subtest ()
455 {
456     if [ -n "$inside_subtest" ]; then
457         exec 1>&6 2>&7          # Restore stdout and stderr
458         error "bug in test script: Missing test_expect_equal in ${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
459     fi
460     test_subtest_name="$1"
461     test_reset_state_
462     # Redirect test output to the previously prepared file descriptors
463     # 3 and 4 (see below)
464     if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
465     exec >&3 2>&4
466     inside_subtest=t
467 }
468
469 # Pass test if two arguments match
470 #
471 # Note: Unlike all other test_expect_* functions, this function does
472 # not accept a test name. Instead, the caller should call
473 # test_begin_subtest before calling this function in order to set the
474 # name.
475 test_expect_equal ()
476 {
477         local output expected testname
478         exec 1>&6 2>&7          # Restore stdout and stderr
479         if [ -z "$inside_subtest" ]; then
480                 error "bug in the test script: test_expect_equal without test_begin_subtest"
481         fi
482         inside_subtest=
483         test "$#" = 2 ||
484         error "bug in the test script: not 2 parameters to test_expect_equal"
485
486         output="$1"
487         expected="$2"
488         if ! test_skip "$test_subtest_name"
489         then
490                 if [ "$output" = "$expected" ]; then
491                         test_ok_
492                 else
493                         testname=$this_test.$test_count
494                         echo "$expected" > $testname.expected
495                         echo "$output" > $testname.output
496                         test_failure_ "$(diff -u $testname.expected $testname.output)"
497                 fi
498     fi
499 }
500
501 # Like test_expect_equal, but takes two filenames.
502 test_expect_equal_file ()
503 {
504         local file1 file2 testname basename1 basename2
505         exec 1>&6 2>&7          # Restore stdout and stderr
506         if [ -z "$inside_subtest" ]; then
507                 error "bug in the test script: test_expect_equal_file without test_begin_subtest"
508         fi
509         inside_subtest=
510         test "$#" = 2 ||
511         error "bug in the test script: not 2 parameters to test_expect_equal_file"
512
513         file1="$1"
514         file2="$2"
515         if ! test_skip "$test_subtest_name"
516         then
517                 if diff -q "$file1" "$file2" >/dev/null ; then
518                         test_ok_
519                 else
520                         testname=$this_test.$test_count
521                         basename1=`basename "$file1"`
522                         basename2=`basename "$file2"`
523                         cp "$file1" "$testname.$basename1"
524                         cp "$file2" "$testname.$basename2"
525                         test_failure_ "$(diff -u "$testname.$basename1" "$testname.$basename2")"
526                 fi
527     fi
528 }
529
530 # Like test_expect_equal, but arguments are JSON expressions to be
531 # canonicalized before diff'ing.  If an argument cannot be parsed, it
532 # is used unchanged so that there's something to diff against.
533 test_expect_equal_json () {
534     local script output expected
535     # The test suite forces LC_ALL=C, but this causes Python 3 to
536     # decode stdin as ASCII.  We need to read JSON in UTF-8, so
537     # override Python's stdio encoding defaults.
538     script='import json, sys; json.dump(json.load(sys.stdin), sys.stdout, sort_keys=True, indent=4)'
539     output=$(echo "$1" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
540         || echo "$1")
541     expected=$(echo "$2" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
542         || echo "$2")
543     shift 2
544     test_expect_equal "$output" "$expected" "$@"
545 }
546
547 # Ensure that the argument is valid JSON data.
548 test_valid_json () {
549     PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "import sys, json; json.load(sys.stdin)" <<<"$1"
550     test_expect_equal "$?" 0
551 }
552
553 # Sort the top-level list of JSON data from stdin.
554 test_sort_json () {
555     PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c \
556         "import sys, json; json.dump(sorted(json.load(sys.stdin)),sys.stdout)"
557 }
558
559 # test for json objects:
560 # read the source of test/json_check_nodes.py (or the output when
561 # invoking it without arguments) for an explanation of the syntax.
562 test_json_nodes () {
563         local output
564         exec 1>&6 2>&7          # Restore stdout and stderr
565         if [ -z "$inside_subtest" ]; then
566                 error "bug in the test script: test_json_eval without test_begin_subtest"
567         fi
568         inside_subtest=
569         test "$#" > 0 ||
570             error "bug in the test script: test_json_nodes needs at least 1 parameter"
571
572         if ! test_skip "$test_subtest_name"
573         then
574             output=$(PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -B "$NOTMUCH_SRCDIR"/test/json_check_nodes.py "$@")
575                 if [ "$?" = 0 ]
576                 then
577                         test_ok_
578                 else
579                         test_failure_ "$output"
580                 fi
581         fi
582 }
583
584 test_emacs_expect_t () {
585         local result
586         test "$#" = 1 ||
587         error "bug in the test script: not 1 parameter to test_emacs_expect_t"
588         if [ -z "$inside_subtest" ]; then
589                 error "bug in the test script: test_emacs_expect_t without test_begin_subtest"
590         fi
591
592         # Run the test.
593         if ! test_skip "$test_subtest_name"
594         then
595                 test_emacs "(notmuch-test-run $1)" >/dev/null
596
597                 # Restore state after the test.
598                 exec 1>&6 2>&7          # Restore stdout and stderr
599                 inside_subtest=
600
601                 # test_emacs may update missing external prerequisites
602                 test_check_missing_external_prereqs_ "$test_subtest_name" && return
603
604                 # Report success/failure.
605                 result=$(cat OUTPUT)
606                 if [ "$result" = t ]
607                 then
608                         test_ok_
609                 else
610                         test_failure_ "${result}"
611                 fi
612         else
613                 # Restore state after the (non) test.
614                 exec 1>&6 2>&7          # Restore stdout and stderr
615                 inside_subtest=
616         fi
617 }
618
619 NOTMUCH_NEW ()
620 {
621     notmuch new "${@}" | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
622 }
623
624 NOTMUCH_DUMP_TAGS ()
625 {
626     # this relies on the default format being batch-tag, otherwise some tests will break
627     notmuch dump --include=tags "${@}" | sed '/^#/d' | sort
628 }
629
630 notmuch_drop_mail_headers ()
631 {
632     $NOTMUCH_PYTHON -c '
633 import email, sys
634 msg = email.message_from_file(sys.stdin)
635 for hdr in sys.argv[1:]: del msg[hdr]
636 print(msg.as_string(False))
637 ' "$@"
638 }
639
640 notmuch_exception_sanitize ()
641 {
642     perl -pe 's/(A Xapian exception occurred at .*[.]cc?):([0-9]*)/\1:XXX/'
643 }
644
645 notmuch_search_sanitize ()
646 {
647     perl -pe 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
648 }
649
650 notmuch_search_files_sanitize ()
651 {
652     notmuch_dir_sanitize
653 }
654
655 notmuch_dir_sanitize ()
656 {
657     sed -e "s,$MAIL_DIR,MAIL_DIR," -e "s,${PWD},CWD,g" "$@"
658 }
659
660 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
661 notmuch_show_sanitize ()
662 {
663     sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
664 }
665 notmuch_show_sanitize_all ()
666 {
667     sed \
668         -e 's| filename:.*| filename:XXXXX|' \
669         -e 's| id:[^ ]* | id:XXXXX |' | \
670         notmuch_date_sanitize
671 }
672
673 notmuch_json_show_sanitize ()
674 {
675     sed \
676         -e 's|"id": "[^"]*",|"id": "XXXXX",|g' \
677         -e 's|"Date": "Fri, 05 Jan 2001 [^"]*0000"|"Date": "GENERATED_DATE"|g' \
678         -e 's|"filename": "signature.asc",||g' \
679         -e 's|"filename": \["/[^"]*"\],|"filename": \["YYYYY"\],|g' \
680         -e 's|"timestamp": 97.......|"timestamp": 42|g' \
681         -e 's|"content-length": [1-9][0-9]*|"content-length": "NONZERO"|g'
682 }
683
684 notmuch_emacs_error_sanitize ()
685 {
686     local command
687     command=$1
688     shift
689     for file in "$@"; do
690         echo "=== $file ==="
691         cat "$file"
692     done | sed \
693         -e 's/^\[.*\]$/[XXX]/' \
694         -e "s|^\(command: \)\{0,1\}/.*/$command|\1YYY/$command|"
695 }
696
697 notmuch_date_sanitize ()
698 {
699     sed \
700         -e 's/^Date: Fri, 05 Jan 2001 .*0000/Date: GENERATED_DATE/'
701 }
702
703 notmuch_uuid_sanitize ()
704 {
705     sed 's/[0-9a-f]\{8\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{12\}/UUID/g'
706 }
707
708 notmuch_built_with_sanitize ()
709 {
710     sed 's/^built_with[.]\(.*\)=.*$/built_with.\1=something/'
711 }
712
713 notmuch_passwd_sanitize ()
714 {
715     ${NOTMUCH_PYTHON} -c'
716 import os, sys, pwd, socket
717
718 pw = pwd.getpwuid(os.getuid())
719 user = pw.pw_name
720 name = pw.pw_gecos.partition(",")[0]
721 fqdn = socket.getaddrinfo(socket.gethostname(), 0, 0, socket.SOCK_STREAM, 0, socket.AI_CANONNAME)[0][3]
722
723 for l in sys.stdin:
724     if user:
725         l = l.replace(user, "USERNAME")
726     if fqdn:
727         l = l.replace(fqdn, "FQDN").replace(".(none)","")
728     if name:
729         l = l.replace(name, "USER_FULL_NAME")
730     sys.stdout.write(l)
731 '
732 }
733
734 notmuch_config_sanitize ()
735 {
736     notmuch_dir_sanitize | notmuch_built_with_sanitize
737 }
738
739 notmuch_show_part ()
740 {
741     awk '/^\014part}/{ f=0 }; { if (f) { print $0 } } /^\014part{ ID: '"$1"'/{ f=1 }'
742 }
743
744 # End of notmuch helper functions
745
746 # Use test_set_prereq to tell that a particular prerequisite is available.
747 #
748 # The prerequisite can later be checked for by using test_have_prereq.
749 #
750 # The single parameter is the prerequisite tag (a simple word, in all
751 # capital letters by convention).
752
753 test_set_prereq () {
754         satisfied="$satisfied$1 "
755 }
756 satisfied=" "
757
758 test_have_prereq () {
759         case $satisfied in
760         *" $1 "*)
761                 : yes, have it ;;
762         *)
763                 ! : nope ;;
764         esac
765 }
766
767 declare -A test_missing_external_prereq_
768 declare -A test_subtest_missing_external_prereq_
769
770 # declare prerequisite for the given external binary
771 test_declare_external_prereq () {
772         local binary
773         binary="$1"
774         test "$#" = 2 && name=$2 || name="$binary(1)"
775
776         if ! hash $binary 2>/dev/null; then
777                 test_missing_external_prereq_["${binary}"]=t
778                 eval "
779 $binary () {
780         test_subtest_missing_external_prereq_[\"${name}\"]=t
781         false
782 }"
783         fi
784 }
785
786 # Explicitly require external prerequisite.  Useful when binary is
787 # called indirectly (e.g. from emacs).
788 # Returns success if dependency is available, failure otherwise.
789 test_require_external_prereq () {
790         local binary
791         binary="$1"
792         if [[ ${test_missing_external_prereq_["${binary}"]} == t ]]; then
793                 # dependency is missing, call the replacement function to note it
794                 eval "$binary"
795         else
796                 true
797         fi
798 }
799
800 # You are not expected to call test_ok_ and test_failure_ directly, use
801 # the text_expect_* functions instead.
802
803 test_ok_ () {
804         if test "$test_subtest_known_broken_" = "t"; then
805                 test_known_broken_ok_
806                 return
807         fi
808         test_success=$(($test_success + 1))
809         if test -n "$NOTMUCH_TEST_QUIET"; then
810                 return 0
811         fi
812         say_color pass "%-6s" "PASS"
813         echo " $test_subtest_name"
814 }
815
816 test_failure_ () {
817         print_test_description
818         if test "$test_subtest_known_broken_" = "t"; then
819                 test_known_broken_failure_ "$@"
820                 return
821         fi
822         test_failure=$(($test_failure + 1))
823         test_failure_message_ "FAIL" "$test_subtest_name" "$@"
824         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
825         return 1
826 }
827
828 test_failure_message_ () {
829         say_color error "%-6s" "$1"
830         echo " $2"
831         shift 2
832         if [ "$#" != "0" ]; then
833                 echo "$@" | sed -e 's/^/        /'
834         fi
835         if test "$verbose" != "t"; then cat test.output; fi
836 }
837
838 test_known_broken_ok_ () {
839         test_reset_state_
840         test_fixed=$(($test_fixed+1))
841         say_color pass "%-6s" "FIXED"
842         echo " $test_subtest_name"
843 }
844
845 test_known_broken_failure_ () {
846         test_reset_state_
847         test_broken=$(($test_broken+1))
848         if [ -z "$NOTMUCH_TEST_QUIET" ]; then
849                 test_failure_message_ "BROKEN" "$test_subtest_name" "$@"
850         else
851                 test_failure_message_ "BROKEN" "$test_subtest_name"
852         fi
853         return 1
854 }
855
856 test_debug () {
857         test "$debug" = "" || eval "$1"
858 }
859
860 test_run_ () {
861         test_cleanup=:
862         if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
863         eval >&3 2>&4 "$1"
864         eval_ret=$?
865         eval >&3 2>&4 "$test_cleanup"
866         return 0
867 }
868
869 test_skip () {
870         test_count=$(($test_count+1))
871         to_skip=
872         for skp in $NOTMUCH_SKIP_TESTS
873         do
874                 case $this_test.$test_count in
875                 $skp)
876                         to_skip=t
877                         break
878                 esac
879                 case $this_test_bare.$test_count in
880                 $skp)
881                         to_skip=t
882                         break
883                 esac
884         done
885         case "$to_skip" in
886         t)
887                 test_report_skip_ "$@"
888                 ;;
889         *)
890                 test_check_missing_external_prereqs_ "$@"
891                 ;;
892         esac
893 }
894
895 test_check_missing_external_prereqs_ () {
896         if [[ ${#test_subtest_missing_external_prereq_[@]} != 0 ]]; then
897                 say_color skip >&1 "missing prerequisites: "
898                 echo ${!test_subtest_missing_external_prereq_[@]} >&1
899                 test_report_skip_ "$@"
900         else
901                 false
902         fi
903 }
904
905 test_report_skip_ () {
906         test_reset_state_
907         say_color skip >&3 "skipping test:"
908         echo " $@" >&3
909         say_color skip "%-6s" "SKIP"
910         echo " $1"
911 }
912
913 test_subtest_known_broken () {
914         test_subtest_known_broken_=t
915 }
916
917 test_expect_success () {
918         exec 1>&6 2>&7          # Restore stdout and stderr
919         if [ -z "$inside_subtest" ]; then
920                 error "bug in the test script: test_expect_success without test_begin_subtest"
921         fi
922         inside_subtest=
923         test "$#" = 1 ||
924         error "bug in the test script: not 1 parameters to test_expect_success"
925
926         if ! test_skip "$test_subtest_name"
927         then
928                 test_run_ "$1"
929                 run_ret="$?"
930                 # test_run_ may update missing external prerequisites
931                 test_check_missing_external_prereqs_ "$test_subtest_name" ||
932                 if [ "$run_ret" = 0 -a "$eval_ret" = 0 ]
933                 then
934                         test_ok_
935                 else
936                         test_failure_ "$1"
937                 fi
938         fi
939 }
940
941 test_expect_code () {
942         exec 1>&6 2>&7          # Restore stdout and stderr
943         if [ -z "$inside_subtest" ]; then
944                 error "bug in the test script: test_expect_code without test_begin_subtest"
945         fi
946         inside_subtest=
947         test "$#" = 2 ||
948         error "bug in the test script: not 2 parameters to test_expect_code"
949
950         if ! test_skip "$test_subtest_name"
951         then
952                 test_run_ "$2"
953                 run_ret="$?"
954                 # test_run_ may update missing external prerequisites,
955                 test_check_missing_external_prereqs_ "$test_subtest_name" ||
956                 if [ "$run_ret" = 0 -a "$eval_ret" = "$1" ]
957                 then
958                         test_ok_
959                 else
960                         test_failure_ "exit code $eval_ret, expected $1" "$2"
961                 fi
962         fi
963 }
964
965 # This is not among top-level (test_expect_success)
966 # but is a prefix that can be used in the test script, like:
967 #
968 #       test_expect_success 'complain and die' '
969 #           do something &&
970 #           do something else &&
971 #           test_must_fail git checkout ../outerspace
972 #       '
973 #
974 # Writing this as "! git checkout ../outerspace" is wrong, because
975 # the failure could be due to a segv.  We want a controlled failure.
976
977 test_must_fail () {
978         "$@"
979         test $? -gt 0 -a $? -le 129 -o $? -gt 192
980 }
981
982 # test_cmp is a helper function to compare actual and expected output.
983 # You can use it like:
984 #
985 #       test_expect_success 'foo works' '
986 #               echo expected >expected &&
987 #               foo >actual &&
988 #               test_cmp expected actual
989 #       '
990 #
991 # This could be written as either "cmp" or "diff -u", but:
992 # - cmp's output is not nearly as easy to read as diff -u
993 # - not all diff versions understand "-u"
994
995 test_cmp () {
996         $GIT_TEST_CMP "$@"
997 }
998
999 # This function can be used to schedule some commands to be run
1000 # unconditionally at the end of the test to restore sanity:
1001 #
1002 #       test_expect_success 'test core.capslock' '
1003 #               git config core.capslock true &&
1004 #               test_when_finished "git config --unset core.capslock" &&
1005 #               hello world
1006 #       '
1007 #
1008 # That would be roughly equivalent to
1009 #
1010 #       test_expect_success 'test core.capslock' '
1011 #               git config core.capslock true &&
1012 #               hello world
1013 #               git config --unset core.capslock
1014 #       '
1015 #
1016 # except that the greeting and config --unset must both succeed for
1017 # the test to pass.
1018
1019 test_when_finished () {
1020         test_cleanup="{ $*
1021                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
1022 }
1023
1024 test_done () {
1025         GIT_EXIT_OK=t
1026         test_results_dir="$TEST_DIRECTORY/test-results"
1027         mkdir -p "$test_results_dir"
1028         test_results_path="$test_results_dir/$this_test"
1029
1030         echo "total $test_count" >> $test_results_path
1031         echo "success $test_success" >> $test_results_path
1032         echo "fixed $test_fixed" >> $test_results_path
1033         echo "broken $test_broken" >> $test_results_path
1034         echo "failed $test_failure" >> $test_results_path
1035         echo "" >> $test_results_path
1036
1037         [ -n "$EMACS_SERVER" ] && test_emacs '(kill-emacs)'
1038
1039         if [ "$test_failure" = "0" ]; then
1040             if [ "$test_broken" = "0" ]; then
1041                 rm -rf "$remove_tmp"
1042             fi
1043             exit 0
1044         else
1045             exit 1
1046         fi
1047 }
1048
1049 emacs_generate_script () {
1050         # Construct a little test script here for the benefit of the user,
1051         # (who can easily run "run_emacs" to get the same emacs environment
1052         # for investigating any failures).
1053         cat <<EOF >"$TMP_DIRECTORY/run_emacs"
1054 #!/bin/sh
1055 export PATH=$PATH
1056 export NOTMUCH_CONFIG=$NOTMUCH_CONFIG
1057
1058 # Here's what we are using here:
1059 #
1060 # --quick               Use minimal customization. This implies --no-init-file,
1061 #                       --no-site-file and (emacs 24) --no-site-lisp
1062 #
1063 # --directory           Ensure that the local elisp sources are found
1064 #
1065 # --load                Force loading of notmuch.el and test-lib.el
1066
1067 exec ${TEST_EMACS} --quick \
1068         --directory "$NOTMUCH_BUILDDIR/emacs" --load notmuch.el \
1069         --directory "$NOTMUCH_SRCDIR/test" --load test-lib.el \
1070         "\$@"
1071 EOF
1072         chmod a+x "$TMP_DIRECTORY/run_emacs"
1073 }
1074
1075 test_emacs () {
1076         # test dependencies beforehand to avoid the waiting loop below
1077         missing_dependencies=
1078         test_require_external_prereq dtach || missing_dependencies=1
1079         test_require_external_prereq emacs || missing_dependencies=1
1080         test_require_external_prereq ${TEST_EMACSCLIENT} || missing_dependencies=1
1081         test -z "$missing_dependencies" || return
1082
1083         if [ -z "$EMACS_SERVER" ]; then
1084                 emacs_tests="$NOTMUCH_SRCDIR/test/${this_test_bare}.el"
1085                 if [ -f "$emacs_tests" ]; then
1086                         load_emacs_tests="--eval '(load \"$emacs_tests\")'"
1087                 else
1088                         load_emacs_tests=
1089                 fi
1090                 server_name="notmuch-test-suite-$$"
1091                 # start a detached session with an emacs server
1092                 # user's TERM (or 'vt100' in case user's TERM is known dumb
1093                 # or unknown) is given to dtach which assumes a minimally
1094                 # VT100-compatible terminal -- and emacs inherits that
1095                 TERM=$SMART_TERM dtach -n "$TEST_TMPDIR/emacs-dtach-socket.$$" \
1096                         sh -c "stty rows 24 cols 80; exec '$TMP_DIRECTORY/run_emacs' \
1097                                 --no-window-system \
1098                                 $load_emacs_tests \
1099                                 --eval '(setq server-name \"$server_name\")' \
1100                                 --eval '(server-start)' \
1101                                 --eval '(orphan-watchdog $$)'" || return
1102                 EMACS_SERVER="$server_name"
1103                 # wait until the emacs server is up
1104                 until test_emacs '()' >/dev/null 2>/dev/null; do
1105                         sleep 1
1106                 done
1107         fi
1108
1109         # Clear test-output output file.  Most Emacs tests end with a
1110         # call to (test-output).  If the test code fails with an
1111         # exception before this call, the output file won't get
1112         # updated.  Since we don't want to compare against an output
1113         # file from another test, so start out with an empty file.
1114         rm -f OUTPUT
1115         touch OUTPUT
1116
1117         ${TEST_EMACSCLIENT} --socket-name="$EMACS_SERVER" --eval "(notmuch-test-progn $*)"
1118 }
1119
1120 test_python () {
1121     # Note: if there is need to print debug information from python program,
1122     # use stdout = os.fdopen(6, 'w') or stderr = os.fdopen(7, 'w')
1123     PYTHONPATH="$NOTMUCH_SRCDIR/bindings/python${PYTHONPATH:+:$PYTHONPATH}" \
1124         $NOTMUCH_PYTHON -B - > OUTPUT
1125 }
1126
1127 test_C () {
1128     local exec_file test_file
1129     exec_file="test${test_count}"
1130     test_file="${exec_file}.c"
1131     cat > ${test_file}
1132     ${TEST_CC} ${TEST_CFLAGS} -I${NOTMUCH_SRCDIR}/test -I${NOTMUCH_SRCDIR}/lib -o ${exec_file} ${test_file} -L${NOTMUCH_BUILDDIR}/lib/ -lnotmuch -ltalloc
1133     echo "== stdout ==" > OUTPUT.stdout
1134     echo "== stderr ==" > OUTPUT.stderr
1135     ./${exec_file} "$@" 1>>OUTPUT.stdout 2>>OUTPUT.stderr
1136     notmuch_dir_sanitize OUTPUT.stdout OUTPUT.stderr | notmuch_exception_sanitize > OUTPUT
1137 }
1138
1139 make_shim () {
1140     local base_name test_file shim_file
1141     base_name="$1"
1142     test_file="${base_name}.c"
1143     shim_file="${base_name}.so"
1144     cat > ${test_file}
1145     ${TEST_CC} ${TEST_CFLAGS} ${TEST_SHIM_CFLAGS} -I${NOTMUCH_SRCDIR}/test -I${NOTMUCH_SRCDIR}/lib -o ${shim_file} ${test_file} ${TEST_SHIM_LDFLAGS}
1146 }
1147
1148 notmuch_with_shim () {
1149     local base_name shim_file
1150     base_name="$1"
1151     shift
1152     shim_file="${base_name}.so"
1153     LD_PRELOAD=${LD_PRELOAD:+:$LD_PRELOAD}:./${shim_file} notmuch-shared "$@"
1154 }
1155
1156 # Creates a script that counts how much time it is executed and calls
1157 # notmuch.  $notmuch_counter_command is set to the path to the
1158 # generated script.  Use notmuch_counter_value() function to get the
1159 # current counter value.
1160 notmuch_counter_reset () {
1161         notmuch_counter_command="$TMP_DIRECTORY/notmuch_counter"
1162         if [ ! -x "$notmuch_counter_command" ]; then
1163                 notmuch_counter_state_path="$TMP_DIRECTORY/notmuch_counter.state"
1164                 cat >"$notmuch_counter_command" <<EOF || return
1165 #!/bin/sh
1166
1167 read count < "$notmuch_counter_state_path"
1168 echo \$((count + 1)) > "$notmuch_counter_state_path"
1169
1170 exec notmuch "\$@"
1171 EOF
1172                 chmod +x "$notmuch_counter_command" || return
1173         fi
1174
1175         echo 0 > "$notmuch_counter_state_path"
1176 }
1177
1178 # Returns the current notmuch counter value.
1179 notmuch_counter_value () {
1180         if [ -r "$notmuch_counter_state_path" ]; then
1181                 read count < "$notmuch_counter_state_path"
1182         else
1183                 count=0
1184         fi
1185         echo $count
1186 }
1187
1188 test_reset_state_ () {
1189         test -z "$test_init_done_" && test_init_
1190
1191         test_subtest_known_broken_=
1192         test_subtest_missing_external_prereq_=()
1193 }
1194
1195 # called once before the first subtest
1196 test_init_ () {
1197         test_init_done_=t
1198
1199         # skip all tests if there were external prerequisites missing during init
1200         test_check_missing_external_prereqs_ "all tests in $this_test" && test_done
1201 }
1202
1203
1204 # Where to run the tests
1205 TEST_DIRECTORY=$NOTMUCH_BUILDDIR/test
1206
1207 . "$NOTMUCH_SRCDIR/test/test-lib-common.sh" || exit 1
1208
1209 emacs_generate_script
1210
1211
1212 # Use -P to resolve symlinks in our working directory so that the cwd
1213 # in subprocesses like git equals our $PWD (for pathname comparisons).
1214 cd -P "$TMP_DIRECTORY" || error "Cannot set up test environment"
1215
1216 if test "$verbose" = "t"
1217 then
1218         exec 4>&2 3>&1
1219 else
1220         exec 4>test.output 3>&4
1221 fi
1222
1223 for skp in $NOTMUCH_SKIP_TESTS
1224 do
1225         to_skip=
1226         for skp in $NOTMUCH_SKIP_TESTS
1227         do
1228                 case "$this_test" in
1229                 $skp)
1230                         to_skip=t
1231                         break
1232                 esac
1233                 case "$this_test_bare" in
1234                 $skp)
1235                         to_skip=t
1236                         break
1237                 esac
1238         done
1239         case "$to_skip" in
1240         t)
1241                 say_color skip >&3 "skipping test $this_test altogether"
1242                 say_color skip "skip all tests in $this_test"
1243                 test_done
1244         esac
1245 done
1246
1247 # Provide an implementation of the 'yes' utility
1248 yes () {
1249         if test $# = 0
1250         then
1251                 y=y
1252         else
1253                 y="$*"
1254         fi
1255
1256         while echo "$y"
1257         do
1258                 :
1259         done
1260 }
1261
1262 # Fix some commands on Windows
1263 case $(uname -s) in
1264 *MINGW*)
1265         # Windows has its own (incompatible) sort and find
1266         sort () {
1267                 /usr/bin/sort "$@"
1268         }
1269         find () {
1270                 /usr/bin/find "$@"
1271         }
1272         sum () {
1273                 md5sum "$@"
1274         }
1275         # git sees Windows-style pwd
1276         pwd () {
1277                 builtin pwd -W
1278         }
1279         # no POSIX permissions
1280         # backslashes in pathspec are converted to '/'
1281         # exec does not inherit the PID
1282         ;;
1283 *)
1284         test_set_prereq POSIXPERM
1285         test_set_prereq BSLASHPSPEC
1286         test_set_prereq EXECKEEPSPID
1287         ;;
1288 esac
1289
1290 test -z "$NO_PERL" && test_set_prereq PERL
1291 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1292
1293 # test whether the filesystem supports symbolic links
1294 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1295 rm -f y
1296
1297 # declare prerequisites for external binaries used in tests
1298 test_declare_external_prereq dtach
1299 test_declare_external_prereq emacs
1300 test_declare_external_prereq ${TEST_EMACSCLIENT}
1301 test_declare_external_prereq ${TEST_GDB}
1302 test_declare_external_prereq gpg
1303 test_declare_external_prereq openssl
1304 test_declare_external_prereq gpgsm
1305 test_declare_external_prereq ${NOTMUCH_PYTHON}
1306 test_declare_external_prereq xapian-metadata
1307 test_declare_external_prereq xapian-delve